/*
***************************************************************************
*
* Datei:
*    RSysEnum.h
*
* Inhalt:
*
* Bemerkungen:
*    Enthlt alle Nummern der verwendeten Gadgets und Mens
*    in RSys. Dient zur Verwaltung der Hilfe durch AmigaGuide.
*
* Erstellungsdatum:
*    17-Jul-93    Rolf Bhme
*
* nderungen:
*    17-Jul-93    Rolf Bhme    Erstellung
*
***************************************************************************
*/

enum RSysNumbers {
/* Main Gadgets */
	GD_TasksGad = 0,
	GD_LibrariesGad,
	GD_MemoryGad,
	GD_PortsGad,
	GD_VolumesGad,
	GD_AssignsGad,
	GD_FontsGad,
	GD_ResourcesGad,
	GD_InterruptsGad,
	GD_WindowsGad,
	GD_ScreensGad,
	GD_HandlerInpGad,
	GD_SystemGad,
	GD_HardwareGad,
	GD_SaveListGad,
	GD_JumpGad,
	GD_ListeLV,
	GD_TextHeader,
	GD_InfoMsgGad,
   GD_NewGad,

/* Action Gadgets */
	GD_FileTypeTGad,
	GD_ActionLV,
	GD_FInfo,
	GD_NextEntryGad,

/* CRC Gadgets */
	GD_FileTGad,
	GD_TypeCRCCYGad,
	GD_SelectFileGad,
	GD_CRCTGad,
	GD_ComputeGad,

/* Crypt */
	GD_SourceStrGad,
	GD_CryptStrGad,
	GD_SelSourceGad,
	GD_SelDestGad,
	GD_CryptGad,
	GD_DeccryptGad,
	GD_PwdGad,
	GD_TypeCYGad,

/* Find */
	GD_DeviceLV,
	GD_SelDevLV,
	GD_PatternGad,
	GD_StartStopGad,
	GD_FoundLV,
	GD_SaveFoundListGad,
	GD_AllGad,
	GD_NoneGad,
	GD_CaseCYGad,
	GD_DirFileCYGad,

/* Format */
	GD_FormatStrGad,
	GD_SelFormatGad,
	GD_DevLV,
	GD_NameGad,
	GD_IconsGad,
	GD_FSCYGad,
	GD_InterCYGad,
	GD_FmtStrGad,
	GD_FormatGad,
	GD_QuickGad,
	GD_CancelGad,

/* Hunks */
	GD_TreeLV,
	GD_SaveGad,
	GD_KindCY,

/* Taskpriority */
	GD_TaskGad,
	GD_PrioGad,
	GD_OkGad,
	GD_CancelPriGad,
	GD_PriIntGad,

/* Save windows */
	GD_WindowsLVGad,
	GD_SaveIFFGad,
	GD_ResetWinGad,

/* Show Font */
	GD_NormalCGad,
	GD_ItalicCGad,
	GD_BoldCGad,
	GD_UnderlineCGad,

/* Text Formatter */
	GD_PrefixSGad,
	GD_PostFixSGad,
	GD_BlankLeftCGad,
	GD_QuoteCGad,
	GD_NoHeaderCGad,
	GD_TextTGad,
	GD_UseGad,
	GD_NoFormatGad,

/* Search Routine */
   GD_SearchSGad,
   GD_SearchOkGad,
   GD_SearchCancelGad,

   MAIN_HELP,

/* Menus */

/* Project */
   MN_Iconify,
   MN_ShowStatus,
   MN_SaveConfiguration,
   MN_About,
   MN_quit,

/* Other Lists */
   MN_SysSoftDeviceList,
   MN_SysVectorList,
   MN_SysCLIList,
   MN_SysSemaphoreList,
   MN_RSysLockList,
   MN_SysResidentProg,
   MN_SysResidentList,
   MN_RSysGetDisplayModes,
   MN_SysBlitterWaitList,
   MN_SysTOFWaitList,
   MN_SysAvailFontsList,
   MN_SysPubScreenList,
   MN_RSysGadgetList,
   MN_SysPrefList,
   MN_SysExtPrinterData,
   MN_SysEnvList,
   MN_SysBrokerList,
   MN_RSysAmigaGuideRefList,

/* Actions */
   MN_CRCSum,
   MN_CryptFile,
   MN_HunkStruct,
   MN_FindFile,
   MN_FormatDisk,
   MN_SaveWindows,
   MN_SysCheckOffs,

/* Internal List */
   MN_SaveCurrentList,
   MN_RestoreList,
   MN_KillList,

/* Flushing */
   MN_RSysFlushAllLibraries,
   MN_RSysFlushAllFonts,
   MN_RSysFlushAll,

/* Clip */
   MN_RSysEntryToClip,
   MN_RSysListToClip,

/* Flags */
   MN_ToggleFastMode,
   MN_ToggleSortMode,
   MN_ToggleWorkingBar,
   MN_ToggleAutoFront,
   MN_ToggleMouseWindow,
   MN_ToggleTopazFont,
   MN_ToggleSpeakMode,
   MN_ToggleAskingMode,
   MN_TextFormatter,

/* External Data */
   MN_ReloadActionFile,
   MN_Reloadhardwaredatas,
   MN_Reloadlibraryoffsets,
   MN_ReloadAGuidecontextnodes,

/* Search */
   MN_FindNext,
   MN_FindPrev,
   MN_Search,

/* Speicher Monitor */
   GD_MemoryLVGad,
   GD_DisplayCYGad,
   GD_SaveCGad,
   GD_ASCIIGad,
   GD_SaveHexGad,
   GD_SaveAsIsGad,
   GD_PageBackwardGad,
   GD_PageForwardGad,
   GD_AddressTGad,
   GD_StartAdrTGad,
   GD_StartAdrGad,
   GD_EntryInfo,
   GD_HeaderLine,
   MONITOR,
   MAXENTRY
};

enum {
	TYPE_DIR,					/*  0  */
	TYPE_FILE,					/*  1  */
	TYPE_ICON,					/*  2  */
	TYPE_TEXT,					/*  3  */
	TYPE_C,						/*  4  */
	TYPE_H,						/*  5  */
	TYPE_ASM,					/*  6  */
	TYPE_I,						/*  7  */
	TYPE_MOD,					/*  8  */
	TYPE_REXX,					/*  9  */
	TYPE_BASIC, 				/*  10 */
	TYPE_TEX,					/*  11 */
	TYPE_METAFONT, 			/*  12 */
	TYPE_GF, 					/*  13 */
	TYPE_TEXFONT,				/*  14 */
	TYPE_TEXDVI,				/*  15 */
	TYPE_FLIB,					/*  16 */
	TYPE_OLDMANX,				/*  17 */
	TYPE_NEWMANX,				/*  18 */
	TYPE_OLDMANXLIB,			/*  19 */
	TYPE_NEWMANXLIB,			/*  20 */
	TYPE_OBJECT,				/*  21 */
	TYPE_LIB,					/*  22 */
	TYPE_EXECUTABLE,			/*  23 */
	TYPE_LIBRARY,				/*  24 */
	TYPE_DEVICE,				/*  25 */
	TYPE_FILESYS,				/*  26 */
	TYPE_HANDLER,				/*  27 */
	TYPE_GIF,					/*  28 */
	TYPE_ILBM,					/*  29 */
	TYPE_ANIM,					/*  30 */
	TYPE_8SVX,					/*  31 */
	TYPE_SMUS,					/*  32 */
	TYPE_FTXT,					/*  33 */
	TYPE_PREFS, 				/*  34 */
	TYPE_TERM,					/*  35 */
	TYPE_IMPLODER, 			/*  36 */
	TYPE_POWERPACKER, 		/*  37 */
	TYPE_ARC,					/*  38 */
	TYPE_LHARC, 				/*  39 */
	TYPE_ZOO,					/*  30 */
	TYPE_ZIP,					/*  41 */
	TYPE_DMS,					/*  42 */
	TYPE_WARP,					/*  43 */
	TYPE_ZOOM,					/*  44 */
	TYPE_WORDPERFECT			/*  45 */
};

enum ListTypes {
	TASKS,						/*  0  */
	LIBRARIES,					/*  1  */
	MEMORY,						/*  2  */
	PORTS,						/*  3  */
	VOLUMES, 					/*  4  */
	ASSIGNS, 					/*  5  */
	FONTS,						/*  6  */
	RESOURCES,					/*  7  */
	INTERRUPTS, 				/*  8  */
	WINDOWS, 					/*  9  */
	SCREENS, 					/*  10 */
	INPUTHDL,					/*  11 */
	SYSINFO, 					/*  12 */
	HARDWARE,					/*  13 */
	HELP, 						/*  14 */
	PREFS,						/*  15 */
	DEVS, 						/*  16 */
	ALLFONTS,					/*  17 */
	ENVVARS, 					/*  18 */
	CLI,							/*  19 */
	RESIDENTS,					/*  20 */
	SEMAPHORES, 				/*  21 */
	SYSVECTORS, 				/*  22 */
	SYSSOFTDEV, 				/*  23 */
	SYSPUBSCR,					/*  24 */
	BLITTERWAIT,				/*  25 */
	TOFWAIT, 					/*  26 */
	COMMODITIES,				/*  27 */
	PRINTERDATA,				/*  28 */
	LIBRARYOFFS,				/*  29 */
	DISPLAYMODES,				/*  30 */
	VOLLOCKS,					/*  31 */
	AGUIDEXREF, 				/*  32 */
	ALLGADGETS,					/*  33 */
	MEMORYAREAS,				/*  34 */
   FAULTMSG,               /*  35 */
   LASTTYPE                /*  36 */
};

enum err_objects {
	BROKER_ERR,
	PORT_ERR,
	FILE_ERR,
	SCREEN_ERR,
	WINDOW_ERR,
	LIBRARY_ERR,
	DEVICE_ERR,
	ICON_ERR,
	GADGET_ERR,
   MENU_ERR,
	ENV_ERR,
	DOS_EXALL_ERR,
	FONT_ERR,
	LIST_NODE_ERR,
	MEMORY_ERR,
	TASK_ERR,
	CLIPBOARD_ERR,
   OWN_OBJECT_ERR,
   DATA_ENTRY_ERR,
   OBJECT_CONTEXT_ERR,
	MISC_ERR
};

enum err_actions {
	DUPLICATE_FAIL,
	CREATE_FAIL,
	FIND_FAIL,
	KILL_FAIL,
	OPEN_FAIL,
	READ_FAIL,
	WRITE_FAIL,
	EXALL_FAIL,
	SIZE_FAIL,
	SAVED_FAIL,
	WRONG_FAIL,
	INFO_FAIL,
	EXIST_FAIL,
	TYPE_FAIL,
	ALLOC_FAIL,
   MODIFY_FAIL,
   LOCK_FAIL
};

enum _field {
	NO_FIELD,
	NO_LIB_ID,
	NO_FLAGS,
	NO_TASK,
	NO_NODE,
	WRONG_TYPE_FMT,
	NO_TYPE,
	NO_TITLE,
	NO_BAUD,
	NO_PARITY,
	NO_HANDSHK,
	NO_HANDLER,
	NO_FILE,
	NO_LOCK,
	BLANK_FIELD,
   NO_FD_FIELD,
   HAS_IMAGE,
   UNKNOWN_FIELD
};

enum _types
{
   END,
   MANU_NR,
   PROD_NR,
   TYPE_NR,
   NAME_STR,
   COMPANY,
   UNKNOWN
};

enum _lotypes
{
   LO_END,
   LO_LIBNAME,
   LO_TYP,
   LO_BASE,
   LO_FUNCTION,
	LO_UNKNOWN
};

